_read_mlx:
;Magneto2_click.c,15 :: 		int read_mlx(){
SUB	SP, SP, #12
STR	LR, [SP, #0]
;Magneto2_click.c,16 :: 		uint16_t datavalue = 0;
;Magneto2_click.c,17 :: 		uint16_t inverted_datavalue = 0;
;Magneto2_click.c,18 :: 		uint16_t checkvalue = 0;
;Magneto2_click.c,20 :: 		Chip_Select = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
STR	R1, [R0, #0]
;Magneto2_click.c,21 :: 		delay_ms(4);
MOVW	R7, #47999
MOVT	R7, #0
NOP
NOP
L_read_mlx0:
SUBS	R7, R7, #1
BNE	L_read_mlx0
NOP
NOP
NOP
;Magneto2_click.c,22 :: 		SPI_Write(0xAA);
MOVS	R0, #170
BL	_SPI_Write+0
;Magneto2_click.c,23 :: 		SPI_Write(0xFF);
MOVS	R0, #255
BL	_SPI_Write+0
;Magneto2_click.c,24 :: 		delay_uS(50);
MOVW	R7, #599
MOVT	R7, #0
NOP
NOP
L_read_mlx2:
SUBS	R7, R7, #1
BNE	L_read_mlx2
NOP
NOP
NOP
;Magneto2_click.c,25 :: 		mlx.buffer[3]=SPI_Read(0xFF);
MOVS	R0, #255
BL	_SPI_Read+0
MOVW	R1, #lo_addr(_mlx+7)
MOVT	R1, #hi_addr(_mlx+7)
STR	R1, [SP, #8]
STRB	R0, [R1, #0]
;Magneto2_click.c,26 :: 		mlx.buffer[2]=SPI_Read(0xFF);
MOVS	R0, #255
BL	_SPI_Read+0
MOVW	R1, #lo_addr(_mlx+6)
MOVT	R1, #hi_addr(_mlx+6)
STR	R1, [SP, #4]
STRB	R0, [R1, #0]
;Magneto2_click.c,27 :: 		delay_uS(40);
MOVW	R7, #479
MOVT	R7, #0
NOP
NOP
L_read_mlx4:
SUBS	R7, R7, #1
BNE	L_read_mlx4
NOP
NOP
NOP
;Magneto2_click.c,28 :: 		mlx.buffer[1]=SPI_Read(0XFF);
MOVS	R0, #255
BL	_SPI_Read+0
MOVW	R1, #lo_addr(_mlx+5)
MOVT	R1, #hi_addr(_mlx+5)
STRB	R0, [R1, #0]
;Magneto2_click.c,29 :: 		mlx.buffer[0]=SPI_Read(0xFF);
MOVS	R0, #255
BL	_SPI_Read+0
MOVW	R1, #lo_addr(_mlx+4)
MOVT	R1, #hi_addr(_mlx+4)
STRB	R0, [R1, #0]
;Magneto2_click.c,30 :: 		delay_us(10);
MOVW	R7, #119
MOVT	R7, #0
NOP
NOP
L_read_mlx6:
SUBS	R7, R7, #1
BNE	L_read_mlx6
NOP
NOP
NOP
;Magneto2_click.c,32 :: 		Chip_Select = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
STR	R1, [R0, #0]
;Magneto2_click.c,35 :: 		datavalue = ((uint16_t) mlx.buffer[3]) << 8;
LDR	R0, [SP, #8]
LDRB	R0, [R0, #0]
LSLS	R1, R0, #8
UXTH	R1, R1
;Magneto2_click.c,36 :: 		datavalue |= ((uint16_t) mlx.buffer[2]);
LDR	R0, [SP, #4]
LDRB	R0, [R0, #0]
ORR	R0, R1, R0, LSL #0
UXTH	R0, R0
; datavalue start address is: 8 (R2)
UXTH	R2, R0
;Magneto2_click.c,38 :: 		checkvalue = datavalue & 1;   // LSB signifies an error, check if there is an error in measurement
AND	R0, R0, #1
UXTH	R0, R0
;Magneto2_click.c,40 :: 		if (checkvalue == 1)
CMP	R0, #1
IT	NE
BNE	L_read_mlx8
; datavalue end address is: 8 (R2)
;Magneto2_click.c,41 :: 		return -1;
MOVW	R0, #65535
SXTH	R0, R0
IT	AL
BAL	L_end_read_mlx
L_read_mlx8:
;Magneto2_click.c,43 :: 		inverted_datavalue = ((uint16_t) mlx.buffer[1]) << 8;
; datavalue start address is: 8 (R2)
MOVW	R0, #lo_addr(_mlx+5)
MOVT	R0, #hi_addr(_mlx+5)
LDRB	R0, [R0, #0]
LSLS	R1, R0, #8
UXTH	R1, R1
;Magneto2_click.c,44 :: 		inverted_datavalue |= ((uint16_t) mlx.buffer[0]);
MOVW	R0, #lo_addr(_mlx+4)
MOVT	R0, #hi_addr(_mlx+4)
LDRB	R0, [R0, #0]
ORR	R0, R1, R0, LSL #0
UXTH	R0, R0
;Magneto2_click.c,47 :: 		if (datavalue != ~inverted_datavalue)
MVN	R0, R0
UXTH	R0, R0
CMP	R2, R0
IT	EQ
BEQ	L_read_mlx9
; datavalue end address is: 8 (R2)
;Magneto2_click.c,48 :: 		return -1;
MOVW	R0, #65535
SXTH	R0, R0
IT	AL
BAL	L_end_read_mlx
L_read_mlx9:
;Magneto2_click.c,52 :: 		mlx.angle = datavalue >> 2;
; datavalue start address is: 8 (R2)
LSRS	R1, R2, #2
; datavalue end address is: 8 (R2)
MOVW	R0, #lo_addr(_mlx+0)
MOVT	R0, #hi_addr(_mlx+0)
STRH	R1, [R0, #0]
;Magneto2_click.c,53 :: 		return 0;
MOVS	R0, #0
SXTH	R0, R0
;Magneto2_click.c,56 :: 		}
L_end_read_mlx:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _read_mlx
_main:
;Magneto2_click.c,59 :: 		void main() {
SUB	SP, SP, #24
;Magneto2_click.c,61 :: 		uint8_t check= 0;
;Magneto2_click.c,62 :: 		float angle = 0.0;
;Magneto2_click.c,66 :: 		&_GPIO_MODULE_USART1_PA9_10 );
MOVW	R0, #lo_addr(__GPIO_MODULE_USART1_PA9_10+0)
MOVT	R0, #hi_addr(__GPIO_MODULE_USART1_PA9_10+0)
PUSH	(R0)
;Magneto2_click.c,65 :: 		_UART_ONE_STOPBIT,
MOVW	R3, #0
;Magneto2_click.c,64 :: 		_UART_NOPARITY,
MOVW	R2, #0
;Magneto2_click.c,63 :: 		UART1_Init_Advanced( 9600,  _UART_8_BIT_DATA,
MOVW	R1, #0
MOVW	R0, #9600
;Magneto2_click.c,66 :: 		&_GPIO_MODULE_USART1_PA9_10 );
BL	_UART1_Init_Advanced+0
ADD	SP, SP, #4
;Magneto2_click.c,67 :: 		Delay_ms(300);
MOVW	R7, #61055
MOVT	R7, #54
NOP
NOP
L_main11:
SUBS	R7, R7, #1
BNE	L_main11
NOP
NOP
NOP
;Magneto2_click.c,69 :: 		UART1_Write_Text("Uart initialized\r\n");
MOVW	R0, #lo_addr(?lstr1_Magneto2_click+0)
MOVT	R0, #hi_addr(?lstr1_Magneto2_click+0)
BL	_UART1_Write_Text+0
;Magneto2_click.c,70 :: 		GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_13 ); // set CS pin as output
MOVW	R1, #8192
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Digital_Output+0
;Magneto2_click.c,74 :: 		SPI3_Init_Advanced(_SPI_FPCLK_DIV64, _SPI_MASTER | _SPI_8_BIT | _SPI_CLK_IDLE_LOW | _SPI_SECOND_CLK_EDGE_TRANSITION | _SPI_MSB_FIRST | _SPI_SS_DISABLE | _SPI_SSM_ENABLE | _SPI_SSI_1, &_GPIO_MODULE_SPI3_PC10_11_12);
MOVW	R2, #lo_addr(__GPIO_MODULE_SPI3_PC10_11_12+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_SPI3_PC10_11_12+0)
MOVW	R1, #773
MOVS	R0, #5
BL	_SPI3_Init_Advanced+0
;Magneto2_click.c,75 :: 		SPI_Set_Active(&SPI3_Read, &SPI3_Write);      // Sets the SPI1 module active
MOVW	R1, #lo_addr(_SPI3_Write+0)
MOVT	R1, #hi_addr(_SPI3_Write+0)
MOVW	R0, #lo_addr(_SPI3_Read+0)
MOVT	R0, #hi_addr(_SPI3_Read+0)
BL	_SPI_Set_Active+0
;Magneto2_click.c,78 :: 		while (1)
L_main13:
;Magneto2_click.c,80 :: 		check = read_mlx();
BL	_read_mlx+0
;Magneto2_click.c,81 :: 		if ( check == 0)                          // if read was successful, print success and angle
UXTB	R0, R0
CMP	R0, #0
IT	NE
BNE	L_main15
;Magneto2_click.c,83 :: 		Uart1_Write_Text("Success \r\n");
MOVW	R0, #lo_addr(?lstr2_Magneto2_click+0)
MOVT	R0, #hi_addr(?lstr2_Magneto2_click+0)
BL	_UART1_Write_Text+0
;Magneto2_click.c,84 :: 		angle = (float) mlx.angle;
MOVW	R0, #lo_addr(_mlx+0)
MOVT	R0, #hi_addr(_mlx+0)
LDRH	R0, [R0, #0]
BL	__UnsignedIntegralToFloat+0
;Magneto2_click.c,85 :: 		angle /= 45.5;
MOVW	R2, #0
MOVT	R2, #16950
BL	__Div_FP+0
;Magneto2_click.c,86 :: 		floattostr(angle,txt);
ADD	R1, SP, #4
MOV	R0, R0
BL	_FloatToStr+0
;Magneto2_click.c,87 :: 		Uart1_Write_Text(txt);
ADD	R0, SP, #4
BL	_UART1_Write_Text+0
;Magneto2_click.c,88 :: 		Uart1_Write_Text("\r\n");
MOVW	R0, #lo_addr(?lstr3_Magneto2_click+0)
MOVT	R0, #hi_addr(?lstr3_Magneto2_click+0)
BL	_UART1_Write_Text+0
;Magneto2_click.c,89 :: 		}
IT	AL
BAL	L_main16
L_main15:
;Magneto2_click.c,91 :: 		Uart1_Write_Text("Fail \r\n");
MOVW	R0, #lo_addr(?lstr4_Magneto2_click+0)
MOVT	R0, #hi_addr(?lstr4_Magneto2_click+0)
BL	_UART1_Write_Text+0
L_main16:
;Magneto2_click.c,93 :: 		Delay_ms(400);                // Wait 400ms
MOVW	R7, #15871
MOVT	R7, #73
NOP
NOP
L_main17:
SUBS	R7, R7, #1
BNE	L_main17
NOP
NOP
NOP
;Magneto2_click.c,94 :: 		}
IT	AL
BAL	L_main13
;Magneto2_click.c,95 :: 		}
L_end_main:
L__main_end_loop:
B	L__main_end_loop
; end of _main
