#line 1 "C:/Users/Viktor/Desktop/magneto2_release/ARM/Magneto2_click.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 4 "C:/Users/Viktor/Desktop/magneto2_release/ARM/Magneto2_click.c"
sbit Chip_Select at GPIOD_ODR.B13;


struct MLX
{
 unsigned int angle;
 unsigned int error_code;
 unsigned char buffer[4];
} mlx;


int read_mlx(){
 uint16_t datavalue = 0;
 uint16_t inverted_datavalue = 0;
 uint16_t checkvalue = 0;

 Chip_Select = 0;
 delay_ms(4);
 SPI_Write(0xAA);
 SPI_Write(0xFF);
 delay_uS(50);
 mlx.buffer[3]=SPI_Read(0xFF);
 mlx.buffer[2]=SPI_Read(0xFF);
 delay_uS(40);
 mlx.buffer[1]=SPI_Read(0XFF);
 mlx.buffer[0]=SPI_Read(0xFF);
 delay_us(10);

 Chip_Select = 1;


 datavalue = ((uint16_t) mlx.buffer[3]) << 8;
 datavalue |= ((uint16_t) mlx.buffer[2]);

 checkvalue = datavalue & 1;

 if (checkvalue == 1)
 return -1;

 inverted_datavalue = ((uint16_t) mlx.buffer[1]) << 8;
 inverted_datavalue |= ((uint16_t) mlx.buffer[0]);


 if (datavalue != ~inverted_datavalue)
 return -1;

 else
 {
 mlx.angle = datavalue >> 2;
 return 0;
 }

}


void main() {
 char txt[20];
 uint8_t check= 0;
 float angle = 0.0;
 UART1_Init_Advanced( 9600, _UART_8_BIT_DATA,
 _UART_NOPARITY,
 _UART_ONE_STOPBIT,
 &_GPIO_MODULE_USART1_PA9_10 );
 Delay_ms(300);

 UART1_Write_Text("Uart initialized\r\n");
 GPIO_Digital_Output( &GPIOD_BASE, _GPIO_PINMASK_13 );



 SPI3_Init_Advanced(_SPI_FPCLK_DIV64, _SPI_MASTER | _SPI_8_BIT | _SPI_CLK_IDLE_LOW | _SPI_SECOND_CLK_EDGE_TRANSITION | _SPI_MSB_FIRST | _SPI_SS_DISABLE | _SPI_SSM_ENABLE | _SPI_SSI_1, &_GPIO_MODULE_SPI3_PC10_11_12);
 SPI_Set_Active(&SPI3_Read, &SPI3_Write);


 while (1)
 {
 check = read_mlx();
 if ( check == 0)
 {
 Uart1_Write_Text("Success \r\n");
 angle = (float) mlx.angle;
 angle /= 45.5;
 floattostr(angle,txt);
 Uart1_Write_Text(txt);
 Uart1_Write_Text("\r\n");
 }
 else
 Uart1_Write_Text("Fail \r\n");

 Delay_ms(400);
 }
}
